<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html lang="en">
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8">
<meta name="description" content="Play MAME on your TV Arcade Monitor or Fixed Frequency Monitor">
<meta name="keywords" content="advancemame advancemenu advancecd advanceboot makebootfat advance advmame advcd advmenu advcomp mame mess linux scale2x arcade retrogame tv monitor control play coinop cabinet retrogaming">
<meta name="author" content="Andrea Mazzoleni">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<link rel="stylesheet" type="text/css" href="style.css">
<title>Advance Projects</title>

<!-- Google Analytics 4 -->
<!-- Google tag (gtag.js) -->
<script async src="https://www.googletagmanager.com/gtag/js?id=G-JE7ZVT424T"></script>
<script>
  window.dataLayer = window.dataLayer || [];
  function gtag(){dataLayer.push(arguments);}
  gtag('js', new Date());

  gtag('config', 'G-JE7ZVT424T');
</script>

<!-- Google Universal Analytics -->
<script type="text/javascript">

  var _gaq = _gaq || [];
  _gaq.push(['_setAccount', 'UA-21967501-3']);
  _gaq.push(['_trackPageview']);

  (function() {
    var ga = document.createElement('script'); ga.type = 'text/javascript'; ga.async = true;
    ga.src = ('https:' == document.location.protocol ? 'https://ssl' : 'http://www') + '.google-analytics.com/ga.js';
    var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(ga, s);
  })();

</script>
</head>
<body>
<div id="header">
<img src="index.jpg" width="1200" height="150" alt="Title">
</div>
<div id="menu">
<a href="/">About</a>
<a href="download">Download</a>
<a href="doc">Documentation</a>
<a href="support">Support</a>
<a href="forum">Forum</a>
<a href="history">History</a>
<a href="cost">Cost</a>
<a href="video-link">Video</a>
<a href="authors">Authors</a>
</div>
<div id="main">


<p>
Documentation of the AdvanceMAME Device Drivers
</p>

<p>
This file describes the video, sound, joystick, mouse
and keyboard drivers used by the Advance programs.
<p>The sections of this document are:<p>
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr><td width="5%"></td><td colspan=3>
<a href="#1">1 Video Drivers</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td colspan=2>
<a href="#1.1">1.1 Types of Drivers</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#1.1.1">1.1.1 Generate drivers</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#1.1.2">1.1.2 System drivers</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td colspan=2>
<a href="#1.2">1.2 Available Generate Drivers</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#1.2.1">1.2.1 fb - Generate Frame Buffer video (Linux)</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#1.2.2">1.2.2 svgalib - Generate SVGA video (Linux) [OBSOLETE]</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#1.2.3">1.2.3 svgaline - Generate SVGA video (DOS) [OBSOLETE]</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#1.2.4">1.2.4 vbeline - Generate VBE video (DOS) [OBSOLETE]</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#1.2.5">1.2.5 vgaline - Generate VGA video (DOS) [OBSOLETE]</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#1.2.6">1.2.6 svgawin - Generate SVGA video (Windows) [OBSOLETE]</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td colspan=2>
<a href="#1.3">1.3 Available System Drivers</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#1.3.1">1.3.1 sdl - System SDL video (Linux, Windows and Mac OS X)</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#1.3.2">1.3.2 slang - System sLang text video (Linux)</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#1.3.3">1.3.3 curses - System curses text video (Linux)</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#1.3.4">1.3.4 vbe - System VBE video (DOS) [OBSOLETE]</a><br>
</td></tr>
<tr><td width="5%"></td><td colspan=3>
<a href="#2">2 Sound Drivers</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td colspan=2>
<a href="#2.1">2.1 Available Drivers</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#2.1.1">2.1.1 alsa - ALSA sound (Linux)</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#2.1.2">2.1.2 oss - OSS sound (Linux)</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#2.1.3">2.1.3 sdl - SDL sound (Linux, Windows and Mac OS X)</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#2.1.4">2.1.4 seal - SEAL sound (DOS) [OBSOLETE]</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#2.1.5">2.1.5 allegro - Allegro sound (DOS) [OBSOLETE]</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#2.1.6">2.1.6 vsync - VSYNC sound (DOS) [OBSOLETE]</a><br>
</td></tr>
<tr><td width="5%"></td><td colspan=3>
<a href="#3">3 Input Drivers</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td colspan=2>
<a href="#3.1">3.1 Available Keyboard Drivers</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#3.1.1">3.1.1 event - Kernel Input-Event interface (Linux)</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#3.1.2">3.1.2 raw - Kernel keyboard (Linux)</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#3.1.3">3.1.3 sdl - SDL keyboard (Linux, Windows and Mac OS X)</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#3.1.4">3.1.4 svgalib - SVGALIB keyboard (Linux) [OBSOLETE]</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#3.1.5">3.1.5 allegro - Allegro keyboard (DOS) [OBSOLETE]</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td colspan=2>
<a href="#3.2">3.2 Available Joystick Drivers</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#3.2.1">3.2.1 event - Kernel Input-Event interface (Linux)</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#3.2.2">3.2.2 raw - Kernel joystick (Linux)</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#3.2.3">3.2.3 sdl - SDL joystick (Linux, Windows and Mac OS X)</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#3.2.4">3.2.4 svgalib - SVGALIB joystick (Linux) [OBSOLETE]</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#3.2.5">3.2.5 allegro - Allegro joystick (DOS) [OBSOLETE]</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#3.2.6">3.2.6 lgrawinput - Light Gun (Windows XP)</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td colspan=2>
<a href="#3.3">3.3 Available Mouse Drivers</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#3.3.1">3.3.1 event - Kernel Input-Event interface (Linux)</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#3.3.2">3.3.2 raw - Serial mouse (Linux)</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#3.3.3">3.3.3 sdl - SDL mouse (Linux, Windows and Mac OS X)</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#3.3.4">3.3.4 svgalib - SVGALIB mouse (Linux) [OBSOLETE]</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#3.3.5">3.3.5 allegro - Allegro mouse (DOS) [OBSOLETE]</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#3.3.6">3.3.6 rawinput - Raw input interface (Windows)</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#3.3.7">3.3.7 cpn - CPN custom driver interface (Windows)</a><br>
</td></tr>
<tr><td width="5%"></td><td colspan=3>
<a href="#4">4 Video Drivers Configuration</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td colspan=2>
<a href="#4.1">4.1 Common Configuration Options</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#4.1.1">4.1.1 device_video</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#4.1.2">4.1.2 device_video_output</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#4.1.3">4.1.3 device_video_overlaysize</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#4.1.4">4.1.4 device_video_cursor</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td colspan=2>
<a href="#4.2">4.2 Generate Configuration Options</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#4.2.1">4.2.1 device_video_clock</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#4.2.2">4.2.2 device_video_modeline</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#4.2.3">4.2.3 device_video_format</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#4.2.4">4.2.4 device_video_singlescan/doublescan/interlace</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#4.2.5">4.2.5 device_color_palette8/br8/bgr15/bgr16/bgr24/bgr32/yuy2</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#4.2.6">4.2.6 device_video_fastchange</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td colspan=2>
<a href="#4.3">4.3 fb Configuration Options</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#4.3.1">4.3.1 device_hdmi/dpi_pclock_low</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#4.3.2">4.3.2 device_fb_fastset</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td colspan=2>
<a href="#4.4">4.4 vbeline Configuration Options</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#4.4.1">4.4.1 device_vbeline_mode</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td colspan=2>
<a href="#4.5">4.5 svgaline Configuration Options</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#4.5.1">4.5.1 device_svgaline_skipboard</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#4.5.2">4.5.2 device_svgaline_divideclock</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td colspan=2>
<a href="#4.6">4.6 svgawin Configuration Options</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#4.6.1">4.6.1 device_svgawin_skipboard</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#4.6.2">4.6.2 device_svgawin_stub</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#4.6.3">4.6.3 device_svgawin_divideclock</a><br>
</td></tr>
<tr><td width="5%"></td><td colspan=3>
<a href="#5">5 Sound Drivers Configuration</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td colspan=2>
<a href="#5.1">5.1 alsa Configuration Options</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#5.1.1">5.1.1 device_alsa_device</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#5.1.2">5.1.2 device_alsa_mixer</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td colspan=2>
<a href="#5.2">5.2 sdl Configuration Options</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#5.2.1">5.2.1 device_sdl_samples</a><br>
</td></tr>
<tr><td width="5%"></td><td colspan=3>
<a href="#6">6 Input Drivers Configuration</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td colspan=2>
<a href="#6.1">6.1 raw Configuration Options</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#6.1.1">6.1.1 device_raw_mousetype[0,1,2,3]</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#6.1.2">6.1.2 device_raw_mousedev[0,1,2,3]</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td colspan=2>
<a href="#6.2">6.2 lgrawinput Configuration Options</a><br>
</td></tr>
<tr><td width="5%"></td><td width="5%"></td><td width="5%"></td><td>
<a href="#6.2.1">6.2.1 device_lgrawinput_calibration</a><br>
</td></tr>
<tr><td width="5%"></td><td colspan=3>
<a href="#7">7 Copyright</a><br>
</td></tr>
</table>
<h2><a name="1">1</a> 
Video Drivers
</h2>
<h3><a name="1.1">1.1</a> 
Types of Drivers
</h3>
The video drivers can be divided in two different categories:
<ul>
<li>
Generate drivers able to program directly the video board.
</li>
<li>
System drivers able to use only the available video modes.
</li>
</ul>
<h4><a name="1.1.1">1.1.1</a> 
Generate drivers
</h4>
This set of drivers is able to program directly the video board
to always generate a perfect video mode with the correct size
and frequency.
<p>
They always work in `fullscreen' output mode and generally
support only a subset of video boards.
<p>
To function correctly these drivers require a correct
configuration of the `device_video_*' options.
<p>
The `Generate' drivers are always the preferred choice.
<h4><a name="1.1.2">1.1.2</a> 
System drivers
</h4>
This set of drivers is able to use only the video modes
available on the operating system.
<p>
They can work in `fullscreen' mode, `window' mode and `zoom'
output mode using the video board hardware acceleration to
stretch the image. The default output mode is `window' if you
run the program in a window manager, otherwise the output
mode `fullscreen' is chosen.
<p>
Please note that these drivers generally need to stretch the
image losing a lot in image quality and speed.
<p>
These drivers don't require any `device_video_*' options
because they cannot control how the video modes are generated.
<h3><a name="1.2">1.2</a> 
Available Generate Drivers
</h3>
The following is the list of all the video drivers supported.
<h4><a name="1.2.1">1.2.1</a> 
fb - Generate Frame Buffer video (Linux)
</h4>
This driver works in Linux and is able to create video modes
using the Linux Kernel Frame Buffer interface.
<p>
All clocks, all RGB bit depths are available.
<p>
This driver is able to use the Linux fb API to synchronize
with the vertical sync of the video mode, but generally
it isn't possible because the low-end drivers don't support
this feature. Anyway, if you run the program as root it can
use the standard VGA registers to detect the vsync.
This is the major limitation compared with the svgalib driver.
<p>
To allow any user to run the program as root, you can
use the following commands to change the executable
permissions:
<p>
<table width="100%" border="0" cellspacing="0" cellpadding="2"><tr><td width="5%"></td><td width="95%">
<pre>
chown root:root /usr/local/bin/advmame
chmod u+s /usr/local/bin/advmame
</pre>
</td></tr></table>
<p>
To use this driver you must activate the Console Frame Buffer
support in your Linux kernel.
<p>
This driver is not available in X (when the environment DISPLAY
variable is defined).
<p>
The Frame Buffer device opened is `/dev/fb0' and `/dev/fb/0', you
can change it setting the FRAMEBUFFER environment variable.
<p>
The generic Frame Buffer `vesafb' driver cannot be used because
it doesn't allow the creation of new video modes. If it's your
only option you can use it through the SDL library.
<h4><a name="1.2.2">1.2.2</a> 
svgalib - Generate SVGA video (Linux) [OBSOLETE]
</h4>
This driver works in Linux and is able to use video modes obtained
tweaking the hardware registers of the recognized SVGA boards using
the SVGALIB library.
<p>
All clocks, all RGB bit depths are available.
This driver is generally able to synchronize with the vertical sync
of the video mode.
<p>
To use these modes your video board must be supported
by a `svgalib' driver listed in the `cardlinx.txt' file.
To use this driver you need to install the SVGALIB library
version 1.9.x.
<p>
To use this driver you need to correctly configure the
SVGALIB HorizSync and VertRefresh options in the
file /etc/vga/libvga.config file.
You must use a range equal or a bit larger than the range
specified with the AdvanceMAME `device_video_clock' option.
<p>
This driver is not available in X (when the environment DISPLAY
variable is defined).
<p>
In the `contrib/svgalib' directory there are various
SVGALIB patches to fix some problems with recent video
boards, and to work with systems with kernel 2.6 and udev.
<h4><a name="1.2.3">1.2.3</a> 
svgaline - Generate SVGA video (DOS) [OBSOLETE]
</h4>
This driver works in DOS and is able to use video modes obtained
tweaking the hardware registers of the recognized SVGA boards.
<p>
All clocks, all RGB bit depths are available.
<p>
To use these modes your video board must be supported
by a `svgaline' driver listed in the `carddos.txt' file.
<p>
This driver is completely independent of the VGA/VBE BIOS
of your board.
<h4><a name="1.2.4">1.2.4</a> 
vbeline - Generate VBE video (DOS) [OBSOLETE]
</h4>
This driver works in DOS and is able to use video modes obtained
tweaking the standard VBE (VESA) BIOS mode changing the hardware
registers of the SVGA.
<p>
All clocks, all RGB bit depths are available.
<p>
To use these modes your video board must be supported
by a `vbeline' driver listed in the `carddos.txt' file.
<p>
These drivers work setting a video mode using the
default VBE2 services and tweak some hardware SVGA
registers to modify the obtained video mode.
The driver `vbe3' is an exception. It requires the
presence of a VBE3 BIOS to change the frequency of the
desired video mode. Unfortunately the standard
VBE3 services don't support a resolution size change.
<p>
The resolution is changed modifying only the standard
VGA registers. This hack may or not may works.
Also the interlaced modes are only rarely supported
by the various VBE3 BIOS because they are very rarely
used in the standard PC monitors.
<p>
If your video board isn't supported by any drivers and
you don't have a VBE3 BIOS you can try installing a
software VESA BIOS like the SciTech Display Doctor.
<h4><a name="1.2.5">1.2.5</a> 
vgaline - Generate VGA video (DOS) [OBSOLETE]
</h4>
This driver works in DOS and is able to use video modes obtained
tweaking the hardware registers of the standard VGA.
<p>
Only the standard VGA pixel clocks 6.29, 7.08, 12.59,
14.16 MHz are available. Only 8 bit color modes. Only
64 kBytes of video memory.
<p>
This driver supports also text modes with pixel clocks
12.59, 14.16, 25.17, 28.32 MHz.
<p>
This driver is completely independent of the VGA BIOS
of your board.
<h4><a name="1.2.6">1.2.6</a> 
svgawin - Generate SVGA video (Windows) [OBSOLETE]
</h4>
This driver works in Windows NT/2000/XP and is able to use video
modes obtained tweaking the hardware registers of the recognized
SVGA boards.
<p>
All clocks, all RGB bit depths are available.
<p>
To use these modes your video board must be supported
by a `svgawin' driver listed in the `cardwin.txt' file.
<p>
To use this driver you need to install the included SVGAWIN
driver. Please read the `svgawin.txt' file carefully.
<p>
This driver is experimental. At present it's only tested on
Windows 2000 with a GeForce 2 board. It may not work will
all the other boards.
<h3><a name="1.3">1.3</a> 
Available System Drivers
</h3>
The following is the list of all the System video drivers supported.
<h4><a name="1.3.1">1.3.1</a> 
sdl - System SDL video (Linux, Windows and Mac OS X)
</h4>
This driver works in Linux, Windows and Mac OS X and is able to
use video modes reported by the SDL graphics library.
<p>
It supports all RGB bit depths available and the YUV mode.
<p>
The output in the YUV mode is generally accelerated, and can
be used to scale the video output to an arbitrary size.
You can enable this feature with the `-device_video_output overlay'
option.
<p>
You can change some options of this driver using the SDL specific
environment variables described in the contrib/sdl/env.txt file.
<h4><a name="1.3.2">1.3.2</a> 
slang - System sLang text video (Linux)
</h4>
This driver works in Linux and is able to use current terminal text
mode from the Linux sLang library.
<h4><a name="1.3.3">1.3.3</a> 
curses - System curses text video (Linux)
</h4>
This driver works in Linux and is able to use current terminal text
mode from the Linux ncurses library.
<h4><a name="1.3.4">1.3.4</a> 
vbe - System VBE video (DOS) [OBSOLETE]
</h4>
This driver works in DOS and is able to use video modes reported
by the VBE BIOS.
<h2><a name="2">2</a> 
Sound Drivers
</h2>
<h3><a name="2.1">2.1</a> 
Available Drivers
</h3>
The following is the list of all the sound drivers supported.
<h4><a name="2.1.1">2.1.1</a> 
alsa - ALSA sound (Linux)
</h4>
This driver works in Linux and it uses the ALSA sound library.
<h4><a name="2.1.2">2.1.2</a> 
oss - OSS sound (Linux)
</h4>
This driver works in Linux and it uses the OSS sound library.
<h4><a name="2.1.3">2.1.3</a> 
sdl - SDL sound (Linux, Windows and Mac OS X)
</h4>
This driver works in Linux, Windows and Mac OS X and it uses
the SDL library.
<p>
It isn't able to use the hardware volume control of the sound card.
The volume changes are simulated reducing the sample values.
<p>
It isn't able to precisely control the amount of bufferized samples.
This means that it may add a small latency on the sound output.
<p>
You can change some options of this driver using the SDL specific
environment variables described in the contrib/sdl/env.txt file.
<h4><a name="2.1.4">2.1.4</a> 
seal - SEAL sound (DOS) [OBSOLETE]
</h4>
This driver works in DOS and it uses the SEAL sound library with
some specific changes for MAME.
<p>
The source patch and the library source can be downloaded from
the MAME site:
<p>
<table width="100%" border="0" cellspacing="0" cellpadding="2"><tr><td width="5%"></td><td width="95%">
<a href="http://www.mame.net/">http://www.mame.net/</a>
<br>
</td></tr></table>
<h4><a name="2.1.5">2.1.5</a> 
allegro - Allegro sound (DOS) [OBSOLETE]
</h4>
This driver works in DOS and it uses the Allegro library.
<h4><a name="2.1.6">2.1.6</a> 
vsync - VSYNC sound (DOS) [OBSOLETE]
</h4>
This driver works in DOS and it uses the VSync sound drivers
from the VSyncMAME emulator.
<p>
More info is in the VSyncMAME page:
<p>
<table width="100%" border="0" cellspacing="0" cellpadding="2"><tr><td width="5%"></td><td width="95%">
<a href="http://vsynchmame.mameworld.net/">http://vsynchmame.mameworld.net/</a>
<br>
</td></tr></table>
<h2><a name="3">3</a> 
Input Drivers
</h2>
<h3><a name="3.1">3.1</a> 
Available Keyboard Drivers
</h3>
The following is the list of all the keyboard drivers supported.
<h4><a name="3.1.1">3.1.1</a> 
event - Kernel Input-Event interface (Linux)
</h4>
This driver works in Linux and it uses the new style input-event
interface of the Linux kernel.
<p>
It supports more than one keyboard at the same time.
<p>
You can change console with ALT+Fx. No other hotkeys are
available. The hotkeys can be optionally disabled.
<p>
For an emergency keyboard restore you can use the emergency
Linux SysRq key. Check:
<p>
<table width="100%" border="0" cellspacing="0" cellpadding="2"><tr><td width="5%"></td><td width="95%">
<pre>
<a href="http:///usr/src/linux/Documentation/sysrq.txt">http:///usr/src/linux/Documentation/sysrq.txt</a>
</pre>
</td></tr></table>
<p>
Leds control is supported.
<h4><a name="3.1.2">3.1.2</a> 
raw - Kernel keyboard (Linux)
</h4>
This driver works in Linux and it uses directly the Linux kernel
keyboard interface.
<p>
It supports only one keyboard.
<p>
You can change console with ALT+Fx and break the program
with CTRL+C. No other hotkeys are available. The hotkeys can
be optionally disabled.
<p>
For an emergency keyboard restore you can use the emergency
Linux SysRq key. Check:
<p>
<table width="100%" border="0" cellspacing="0" cellpadding="2"><tr><td width="5%"></td><td width="95%">
<pre>
<a href="http:///usr/src/linux/Documentation/sysrq.txt">http:///usr/src/linux/Documentation/sysrq.txt</a>
</pre>
</td></tr></table>
<p>
Leds control is supported.
<h4><a name="3.1.3">3.1.3</a> 
sdl - SDL keyboard (Linux, Windows and Mac OS X)
</h4>
This driver works in Linux, Windows and Mac OS X and it uses
the SDL library.
<p>
It supports only one keyboard.
<p>
You can change some options of this driver using the SDL specific
environment variables described in the contrib/sdl/env.txt file.
<p>
In a Window Manager environment you can switch to fullscreen
pressing ALT+ENTER.
<p>
Leds control is not supported.
<h4><a name="3.1.4">3.1.4</a> 
svgalib - SVGALIB keyboard (Linux) [OBSOLETE]
</h4>
This driver works in Linux and it uses the SVGALIB library.
<p>
It supports only one keyboard.
<p>
You can change console with ALT+Fx and break the program
with CTRL+C. No other hotkeys are available. The CTRL+C hotkey
can be optionally disabled. The ALT+Fx hotkeys are always
enabled.
<p>
For an emergency keyboard restore you can use the emergency
Linux SysRq key. Check:
<p>
<table width="100%" border="0" cellspacing="0" cellpadding="2"><tr><td width="5%"></td><td width="95%">
<pre>
<a href="http:///usr/src/linux/Documentation/sysrq.txt">http:///usr/src/linux/Documentation/sysrq.txt</a>
</pre>
</td></tr></table>
<p>
Leds control is not supported.
<h4><a name="3.1.5">3.1.5</a> 
allegro - Allegro keyboard (DOS) [OBSOLETE]
</h4>
This driver works in DOS and it uses the Allegro library.
<p>
It supports only one keyboard.
<p>
You can break the program pressing CTRL+C, CTRL+BREAK or ALT+CTRL+END.
<p>
Leds control is supported.
<h3><a name="3.2">3.2</a> 
Available Joystick Drivers
</h3>
The following is the list of all the joystick drivers supported.
<h4><a name="3.2.1">3.2.1</a> 
event - Kernel Input-Event interface (Linux)
</h4>
This driver works in Linux and it uses the new style input-event
interface of the Linux kernel.
<p>
It supports more than one joystick or light-gun at the same time.
<p>
For USB devices this driver doesn't require any configuration.
It's able to autodetect all the present hardware.
<p>
This driver is also able to correctly report the type of devices
found. You should for example expects to have the gas pedal mapped
on the gas control of the game.
<p>
It can also be used with some custom devices connected at the
Parallel Port. Details on how to build these custom interfaces are
in the <a href="file:///usr/src/linux/Documentation/input/joystick-parport.txt">file:///usr/src/linux/Documentation/input/joystick-parport.txt</a>
file.
<p>
It has a special support for the ACT Labs Lightgun to fix the wrong
behavior of the light-gun when shooting out of screen.
<p>
The joysticks are searched on the /dev/input/eventX devices.
<p>
If you have a gameport joystick, the Linux Kernel Joystick driver
may prevent a correct video vsync if the joystick polling is too slow.
Generally it results in a missing frame every 5-10 seconds.
<h4><a name="3.2.2">3.2.2</a> 
raw - Kernel joystick (Linux)
</h4>
This driver works in Linux and it uses directly the Linux kernel
joystick interface.
<p>
It supports up to 4 joysticks at the same time.
<p>
The joysticks are searched on the /dev/jsX and /dev/input/jsX devices.
<p>
If you have a gameport joystick, the Linux Kernel Joystick driver
may prevent a correct video vsync if the joystick polling is too slow.
Generally it results in a missing frame every 5-10 seconds.
<h4><a name="3.2.3">3.2.3</a> 
sdl - SDL joystick (Linux, Windows and Mac OS X)
</h4>
This driver works in Linux, Windows and Mac OS X and it uses
the SDL joystick interface.
<p>
It supports more than one joystick at the same time.
<p>
You can change some options of this driver using the SDL specific
environment variables described in the contrib/sdl/env.txt file.
<h4><a name="3.2.4">3.2.4</a> 
svgalib - SVGALIB joystick (Linux) [OBSOLETE]
</h4>
This driver works in Linux and it uses the SVGALIB library.
<p>
It supports up to 4 joysticks at the same time.
<p>
The joysticks are searched on the /dev/jsX devices.
<p>
If you have a gameport joystick, the Linux Kernel Joystick driver
may prevent a correct video vsync if the joystick polling is too slow.
Generally it results in a missing frame every 5-10 seconds.
<h4><a name="3.2.5">3.2.5</a> 
allegro - Allegro joystick (DOS) [OBSOLETE]
</h4>
This driver works in DOS and it uses the Allegro library.
<p>
It supports only one joystick.
<p>
Details on how to build the Parallel Port hardware interfaces for
SNES, PSX, N64 and other pads are in the Allegro sources.
<h4><a name="3.2.6">3.2.6</a> 
lgrawinput - Light Gun (Windows XP)
</h4>
This driver works in Windows XP and it support lightguns
using the Windows mouse interface.
<p>
It supports more than one lightgun at the same time
of the following types:
<ul>
<li>
SMOG Lightgun (http://lightgun.splinder.com/)
</li>
<li>
Acts Labs Lightgun (http://www.act-labs.com/)
</li>
</ul>
<p>
The lightgun is automatically calibrated before
every use. You must move the lightgun over the whole
screen every time the program starts or changes video
mode.
<h3><a name="3.3">3.3</a> 
Available Mouse Drivers
</h3>
The following is the list of all the mouse drivers supported.
<h4><a name="3.3.1">3.3.1</a> 
event - Kernel Input-Event interface (Linux)
</h4>
This driver works in Linux and it uses the new style input-event
interface of the Linux kernel.
<p>
It supports more than one mouse at the same time.
<p>
For USB devices this driver doesn't require any configuration.
It's able to autodetect all the present hardware.
<p>
For serial mouse you must use the `inputattach' system
utility to attach the serial line at the event interface.
Generally this utility is available in the joystick
calibration package of your distribution. In this case it's
probably simpler to use the `raw' mouse driver.
<p>
The mice are searched on the /dev/input/eventX devices.
<h4><a name="3.3.2">3.3.2</a> 
raw - Serial mouse (Linux)
</h4>
This driver works in Linux and it communicates directly with
the configured serial mice. It also supports USB mice
using the Linux mousedev module which maps mice to the
/dev/input/mouseX devices.
<p>
It supports more than one mouse at the same time.
<p>
To use this driver you need to configure correctly the
device_raw_* options to specify the mouse types and the mouse
devices.
<h4><a name="3.3.3">3.3.3</a> 
sdl - SDL mouse (Linux, Windows and Mac OS X)
</h4>
This driver works in Linux, Windows and Mac OS X and it uses
the SDL mouse interface.
<p>
It supports only one mouse and only two axes.
<p>
You can change some options of this driver using the SDL specific
environment variables described in the contrib/sdl/env.txt file.
<h4><a name="3.3.4">3.3.4</a> 
svgalib - SVGALIB mouse (Linux) [OBSOLETE]
</h4>
This driver works in Linux and it uses the SVGALIB library.
<p>
It supports only one mouse.
<p>
To use this driver you need to configure correctly the
SVGALIB mouse support in the file /etc/vga/libvga.config file.
<h4><a name="3.3.5">3.3.5</a> 
allegro - Allegro mouse (DOS) [OBSOLETE]
</h4>
This driver works in DOS and it uses the Allegro library.
<p>
It supports up to 2 mice at the same time using the
special `optimous' driver present in the `contrib/' directory.
<h4><a name="3.3.6">3.3.6</a> 
rawinput - Raw input interface (Windows)
</h4>
This driver works in Windows XP using the raw input interface.
<p>
It supports more than one mouse at the same time.
<p>
For any mouse up to two axes, one wheel and five buttons
are supported.
<p>
This driver is the preferred choice for Windows XP.
<p>
Please note that this driver is not intented to be used in a window
environment. The application takes the control of the mouse and
doesn't allow to switch to other applications. It's mainly intented
for a fullscreen environment.
<h4><a name="3.3.7">3.3.7</a> 
cpn - CPN custom driver interface (Windows)
</h4>
This driver works in Windows 2000/XP using the custom CPN
mouse driver.
<p>
It supports more than one mouse at the same time.
<p>
For any mouse up to two axes, and three buttons are supported.
<p>
The CPN mouse driver is available at:
<p>
<table width="100%" border="0" cellspacing="0" cellpadding="2"><tr><td width="5%"></td><td width="95%">
<a href="http://cpnmouse.sourceforge.net/">http://cpnmouse.sourceforge.net/</a>
<br>
</td></tr></table>
<p>
and in the `contrib/cpn' directory. Check the `install'
and `unknown' files for install instructions.
<p>
Please note that this driver is not intented to be used in a window
environment. The application takes the control of the mouse and
doesn't allow to switch to other applications. It's mainly intented
for a fullscreen environment.
<h2><a name="4">4</a> 
Video Drivers Configuration
</h2>
The following are the video configuration options available for
all the programs.
<h3><a name="4.1">4.1</a> 
Common Configuration Options
</h3>
<h4><a name="4.1.1">4.1.1</a> 
device_video
</h4>
Selects the video driver to use.
<p>
<pre>
device_video auto | (DEVICE[/MODEL])+
</pre>
<p>
Options:
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
auto
</em></td><td width="90%">
Automatic detection of all the available drivers
(default).
</td></tr>
</table>
<p>
The order of detection:
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
DOS
</em></td><td width="90%">
svgaline, vbeline, vgaline, vbe.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
Linux
</em></td><td width="90%">
svgalib, fb, sdl, slang, curses.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
Mac OS X
</em></td><td width="90%">
sdl.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
Windows
</em></td><td width="90%">
svgawin, sdl.
</td></tr>
</table>
<p>
Options for Linux:
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
svgalib
</em></td><td width="90%">
SVGA generated graphics modes with the
SVGALIB 1.9.x library.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
fb
</em></td><td width="90%">
SVGA generated graphics modes with the Linux Console
Frame Buffer.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
slang
</em></td><td width="90%">
Text video modes with the sLang library.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
curses
</em></td><td width="90%">
Text video modes with the ncurses library.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
sdl
</em></td><td width="90%">
SDL graphics and fake text modes.
</td></tr>
</table>
<p>
Options for Mac OS X:
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
sdl
</em></td><td width="90%">
SDL graphics and fake text modes.
</td></tr>
</table>
<p>
Options for DOS:
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
svgaline
</em></td><td width="90%">
SVGA generated graphics modes.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
svgaline/nv3_leg
</em></td><td width="90%">
SVGA legacy driver for nVidia boards.
If the new driver doesn't work try this one.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
svgaline/savage_leg
</em></td><td width="90%">
SVGA legacy driver for S3 boards.
If the new driver doesn't work try this one.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
vbeline
</em></td><td width="90%">
VBE generated graphics modes.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
vgaline
</em></td><td width="90%">
VGA generated text and graphics modes.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
vbe
</em></td><td width="90%">
VBE graphics modes.
</td></tr>
</table>
<p>
Options for Windows:
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
svgawin
</em></td><td width="90%">
SVGA generated graphics modes with the
SVGAWIN included library. To use this driver you
need to install the `svgawin.sys' driver with the
`svgawin.exe' command line utility.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
svgawin/nv3_leg
</em></td><td width="90%">
SVGA legacy driver for nVidia boards.
If the new driver doesn't work try this one.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
svgawin/savage_leg
</em></td><td width="90%">
SVGA legacy driver for S3 boards.
If the new driver doesn't work try this one.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
sdl
</em></td><td width="90%">
SDL graphics and fake text modes.
</td></tr>
</table>
<p>
Please note that to use the utilities `advv' and `advcfg' you
must at least select a graphics and a text video driver. The
available text video drivers are `vgaline' for DOS, `slang',
`curses' for Linux and `sdl' for Windows.
<p>
You can force the detection of a specific model of video board
adding the name of the model driver after the driver name using
the `/' separator. For example to force the `vbe3' model
detection of the `vbeline' driver you must specify
`vbeline/vbe3'.
<p>
To get the list of all the available models try using the
`help' model name. A short help will be printed.
<p>
Please note that forcing a specific video driver is discouraged.
Generally you don't need it.
<p>
For a more complete description of the drivers check the
previous `VIDEO DRIVER' section.
<p>
Example to enable the `vbeline' and the `vgaline' drivers
with auto-detection for DOS:
<table width="100%" border="0" cellspacing="0" cellpadding="2"><tr><td width="5%"></td><td width="95%">
<pre>
device_video vbeline vgaline
</pre>
</td></tr></table>
<p>
Example to force the `vbeline/vbe3' driver and the `vgaline'
driver for DOS:
<table width="100%" border="0" cellspacing="0" cellpadding="2"><tr><td width="5%"></td><td width="95%">
<pre>
device_video vbeline/vbe3 vgaline
</pre>
</td></tr></table>
<p>
Example to enable the `fb' and `slang' driver for Linux:
<table width="100%" border="0" cellspacing="0" cellpadding="2"><tr><td width="5%"></td><td width="95%">
<pre>
device_video fb slang
</pre>
</td></tr></table>
<h4><a name="4.1.2">4.1.2</a> 
device_video_output
</h4>
Select the output mode.
<p>
<pre>
device_video_output auto | window | fullscreen | overlay
</pre>
<p>
Options:
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
auto
</em></td><td width="90%">
Automatically chosen (default).
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
window
</em></td><td width="90%">
Use a window display.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
fullscreen
</em></td><td width="90%">
Use a fullscreen display.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
overlay
</em></td><td width="90%">
Use a YUV fullscreen overlay using the video board
hardware acceleration to display and stretch it.
This mode is available only in some environments, like
xv in X Window and DirectX in Windows. The specific
color format used is YUY2.
</td></tr>
</table>
<h4><a name="4.1.3">4.1.3</a> 
device_video_overlaysize
</h4>
Select the favorite horizontal size to use with the `overlay'
output mode. The program selects the nearest available video mode.
<p>
device_video_overlaysize auto | SIZE
<p>
Options:
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
auto
</em></td><td width="90%">
Use the size of the current video mode (default).
If not available tries 1280x1024.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
SIZE
</em></td><td width="90%">
The user favorite horizontal size.
</td></tr>
</table>
<p>
This option has effect only with the `overlay' output mode.
<h4><a name="4.1.4">4.1.4</a> 
device_video_cursor
</h4>
Select the mouse cursor mode.
<p>
<pre>
device_video_cursor auto | off | on
</pre>
<p>
Options:
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
auto
</em></td><td width="90%">
Automatically choose (default). The cursor
is enabled in window modes, and disabled
in fullscreen modes.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
off
</em></td><td width="90%">
Always off.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
on
</em></td><td width="90%">
Always on, only if the video mode support it.
</td></tr>
</table>
<h3><a name="4.2">4.2</a> 
Generate Configuration Options
</h3>
The following are the common video configuration options
available for all `generate' video drivers, i.e. all the
video drivers with the exception of `sdl' and `vbe'.
The `sdl' and `vbe' video drivers simply ignore these
options.
<h4><a name="4.2.1">4.2.1</a> 
device_video_clock
</h4>
Specify the monitor frequency range in term of horizontal and
vertical clocks. This option is MANDATORY.
Generally these values are specified in the technical page of
your monitor manual.
<p>
<pre>
device_video_clock PIXEL_CLOCK / HORZ_CLOCK / VERT_CLOCK [; ...]
</pre>
<p>
Options:
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
PIXEL_CLOCK
</em></td><td width="90%">
Pixel clock range in MHz.
The lower value is the lower clock generable
by your video board. The higher value is the
video bandwidth of your monitor. If you
don't know these values you can start
with `5 - 100' which essentially enable any
video mode.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
HORZ_CLOCK
</em></td><td width="90%">
Horizontal clock range in kHz.
</td></tr>
</table>
<p>
<table width="100%" border="0" cellspacing="0" cellpadding="2"><tr><td width="5%"></td><td width="95%">
VERT_CLOCK- Vertical clock range in Hz.
</td></tr></table>
<p>
For any range you can specify a single value like `60' or a
range of values like `50 - 60'. For multistandard TVs and monitors
you can use more clock specifications separating them with `;'.
<p>
For example:
<table width="100%" border="0" cellspacing="0" cellpadding="2"><tr><td width="5%"></td><td width="95%">
<pre>
device_video_clock 5 - 50 / 15.62 / 50 ; 5 - 50 / 15.73 / 60
</pre>
</td></tr></table>
<p>
Check the `install.txt' file for examples and other information.
<h4><a name="4.2.2">4.2.2</a> 
device_video_modeline
</h4>
Define a video modeline. The modeline format is compatible with
the format used by the Linux SVGALIB library and by the
XFree Window system.
<p>
<pre>
device_video_modeline Name CLOCK HDE HRS HRE HT VDE VRS VRE VT
&nbsp;&nbsp;&nbsp;&nbsp;[-hsync] [-vsync] [+hsync] [+vsync] [doublescan] [interlace]
</pre>
<p>
Options:
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
Name
</em></td><td width="90%">
Name of the video mode. You can use the quotes
'"` for the names with spaces.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
CLOCK
</em></td><td width="90%">
Pixel clock in MHz
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
HDE HRS HRE HT
</em></td><td width="90%">
Horizontal `Display End',
`Retrace Start', `Retrace End', `Total'
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
VDE VRS VRE VT
</em></td><td width="90%">
Vertical `Display End',
`Retrace Start', `Retrace End', `Total'
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
-hsync -vsync +hsync +vsync
</em></td><td width="90%">
Polarization mode.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
doublescan
</em></td><td width="90%">
Doublescan mode.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
interlace
</em></td><td width="90%">
Interlaced mode.
</td></tr>
</table>
<p>
Examples:
<table width="100%" border="0" cellspacing="0" cellpadding="2"><tr><td width="5%"></td><td width="95%">
<pre>
device_video_modeline tweak320x240 12.59 320 336 356 400 240 \
&nbsp;&nbsp;&nbsp;&nbsp;249 254 262 doublescan -hsync -vsync
</pre>
</td></tr></table>
<h4><a name="4.2.3">4.2.3</a> 
device_video_format
</h4>
Select the format of the video modes to create.
You can insert more than one of these option.
<p>
<pre>
device_video_format HCLOCK HDE HRS HRE HT VDE VRS VRE VT
</pre>
<p>
Options:
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
HCLOCK
</em></td><td width="90%">
Horizontal clock in Hz
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
HDE HRS HRE HT VDE VRS VRE VT
</em></td><td width="90%">
Like the modeline option
</td></tr>
</table>
<p>
When a new modeline is created, AdvanceMAME uses a linear
interpolation of the two formats with the nearest horizontal
clock.
<p>
The default value of this option is for an Arcade 15 kHz monitor:
<p>
<table width="100%" border="0" cellspacing="0" cellpadding="2"><tr><td width="5%"></td><td width="95%">
<pre>
15720 0.737 0.075 0.074 0.113 0.916 0.012 0.012 0.060
</pre>
</td></tr></table>
<p>
and for an Arcade 25 kHz monitor:
<p>
<table width="100%" border="0" cellspacing="0" cellpadding="2"><tr><td width="5%"></td><td width="95%">
<pre>
25000 0.800 0.020 0.100 0.080 0.922 0.006 0.012 0.060
</pre>
</td></tr></table>
<p>
and for a VGA 31.5 kHz monitor:
<p>
<table width="100%" border="0" cellspacing="0" cellpadding="2"><tr><td width="5%"></td><td width="95%">
<pre>
31500 0.800 0.020 0.120 0.060 0.914 0.019 0.004 0.063
</pre>
</td></tr></table>
<p>
Which one of these defaults is used depends on the setting of the
`device_video_clock' option.
<h4><a name="4.2.4">4.2.4</a> 
device_video_singlescan/doublescan/interlace
</h4>
Limit the use of certain features.
<p>
<pre>
device_video_singlescan yes | no
device_video_doublescan yes | no
device_video_interlace yes | no
</pre>
<p>
Options:
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
yes
</em></td><td width="90%">
Permits the use of the feature if the
low-end driver allows it (default).
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
no
</em></td><td width="90%">
Disable completely the feature.
</td></tr>
</table>
<h4><a name="4.2.5">4.2.5</a> 
device_color_palette8/br8/bgr15/bgr16/bgr24/bgr32/yuy2
</h4>
Limit the use of some bit depths. If you known that
the program doesn't work well with a specific bit depth you
can disable it.
<p>
<pre>
device_color_palette8 yes | no
device_color_bgr8 yes | no
device_color_bgr15 yes | no
device_color_bgr16 yes | no
device_color_bgr24 yes | no
device_color_bgr32 yes | no
device_color_yuy2 yes | no
</pre>
<p>
Modes:
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
palette8
</em></td><td width="90%">
Palettized 8 bits mode.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
bgr8
</em></td><td width="90%">
RGB 8 bits mode.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
bgr15
</em></td><td width="90%">
RGB 15 bits mode.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
bgr16
</em></td><td width="90%">
RGB 16 bits mode.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
bgr24
</em></td><td width="90%">
RGB 24 bits mode.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
bgr32
</em></td><td width="90%">
RGB 32 bits mode.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
yuy2
</em></td><td width="90%">
YUV mode in the YUY2 format.
</td></tr>
</table>
<p>
Options:
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
yes
</em></td><td width="90%">
Permits the use of the bit depth if the
low-end driver allows it (default).
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
no
</em></td><td width="90%">
Disable completely the bit depth.
</td></tr>
</table>
<h4><a name="4.2.6">4.2.6</a> 
device_video_fastchange
</h4>
Enable or disable the fast video mode change. If enabled the
current video mode is not reset before setting another video
mode. The reset isn't generally required, but some
limited DOS video BIOS need it. So, the fast change is disabled
for default.
<p>
<pre>
device_video_fastchange yes | no
</pre>
<p>
Options:
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
yes
</em></td><td width="90%">
Enable the fast video mode change.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
no
</em></td><td width="90%">
Disable the fast video mode change (default).
</td></tr>
</table>
<h3><a name="4.3">4.3</a> 
fb Configuration Options
</h3>
<h4><a name="4.3.1">4.3.1</a> 
device_hdmi/dpi_pclock_low
</h4>
Set the minimum pclock frequency used to drive the display. If a lower
value is selected, transparently increases the video mode horizontal size
until it reaches the allowed pixel clock.
<p>
This option works only with Raspberry Pi, when using the FrameBuffer and
the HDMI/DPI video interface.
<p>
The use of this option is discouraged, it's present only for testing.
<p>
<pre>
device_hdmi_pclock_low PCLOCK
device_dpi_pclock_low PCLOCK
</pre>
<p>
Options:
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
PCLOCK
</em></td><td width="90%">
Pixel clock in Hz (default 0 for HDMI,
and 31.25 MHz for DPI).
</td></tr>
</table>
<h4><a name="4.3.2">4.3.2</a> 
device_fb_fastset
</h4>
Don't set the video mode if it's expected to be idential at the
current one. This can be used to avoid a screen refresh
when not required.
<p>
<pre>
device_fb_fastset yes | no
</pre>
<p>
Options:
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
yes
</em></td><td width="90%">
Don't set identical video mode.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
no
</em></td><td width="90%">
Always set the video mode (default).
</td></tr>
</table>
<h3><a name="4.4">4.4</a> 
vbeline Configuration Options
</h3>
The following are the common video configuration options
available only for the `vbeline' DOS video driver.
<h4><a name="4.4.1">4.4.1</a> 
device_vbeline_mode
</h4>
Select which `vbe' mode to use when generating `vbeline' modes.
<p>
The use of this option is discouraged, it's present only for testing.
<p>
<pre>
device_vbeline_mode smaller | bigger | ...
</pre>
<p>
Options:
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
smaller
</em></td><td width="90%">
Use the biggest `vbe' mode contained in
the `vbeline' mode (default).
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
bigger
</em></td><td width="90%">
Use the smallest `vbe' mode which contains
the `vbeline' mode.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
smaller_upto640
</em></td><td width="90%">
Like `smaller' but not
bigger than 640x480.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
bigger_upto640
</em></td><td width="90%">
Like `bigger' but not
bigger than 640x480.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
320
</em></td><td width="90%">
Use always the 320x240 mode.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
400
</em></td><td width="90%">
Use always the 400x300 mode.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
512
</em></td><td width="90%">
Use always the 512x384 mode.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
640
</em></td><td width="90%">
Use always the 640x480 mode.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
800
</em></td><td width="90%">
Use always the 800x600 mode.
</td></tr>
</table>
<h3><a name="4.5">4.5</a> 
svgaline Configuration Options
</h3>
The following are the common video configuration options
available only for the `svgaline' DOS video driver.
<h4><a name="4.5.1">4.5.1</a> 
device_svgaline_skipboard
</h4>
Selects how many board skip in the video card detection. If you have
more than a video card on your system you and the wrong one is
used you can force to skip an arbitrary number of video boards.
<p>
<pre>
device_svgaline_skipboard 0 | 1 | 2 | 3
</pre>
<p>
Options:
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
0
</em></td><td width="90%">
Don't skip any board (default).
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
1
</em></td><td width="90%">
Skip 1 boards.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
2
</em></td><td width="90%">
Skip 2 boards.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
3
</em></td><td width="90%">
Skip 3 boards.
</td></tr>
</table>
<p>
Examples:
<table width="100%" border="0" cellspacing="0" cellpadding="2"><tr><td width="5%"></td><td width="95%">
<pre>
device_svgaline_skipboard 1
</pre>
</td></tr></table>
<h4><a name="4.5.2">4.5.2</a> 
device_svgaline_divideclock
</h4>
Divide the pixelclock using the VGA sequencer. It should help to support
lower pixel clocks on some boards.
<p>
The use of this option is discouraged, it's present only for testing.
<p>
<pre>
device_svgaline_divideclock yes | no
</pre>
<p>
Options:
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
yes
</em></td><td width="90%">
Divide the clock by 2.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
no
</em></td><td width="90%">
Don't divide the clock (default).
</td></tr>
</table>
<h3><a name="4.6">4.6</a> 
svgawin Configuration Options
</h3>
The following are the common video configuration options
available only for the `svgawin' Windows video driver.
<h4><a name="4.6.1">4.6.1</a> 
device_svgawin_skipboard
</h4>
Selects how many board skip in the video card detection. If you have
more than a video card on your system you and the wrong one is
used you can force to skip an arbitrary number of video boards.
<p>
<pre>
device_svgawin_skipboard 0 | 1 | 2 | 3
</pre>
<p>
Options:
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
0
</em></td><td width="90%">
Don't skip any board (default).
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
1
</em></td><td width="90%">
Skip 1 boards.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
2
</em></td><td width="90%">
Skip 2 boards.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
3
</em></td><td width="90%">
Skip 3 boards.
</td></tr>
</table>
<p>
Examples:
<table width="100%" border="0" cellspacing="0" cellpadding="2"><tr><td width="5%"></td><td width="95%">
<pre>
device_svgawin_skipboard 1
</pre>
</td></tr></table>
<h4><a name="4.6.2">4.6.2</a> 
device_svgawin_stub
</h4>
Selects how the driver uses the Windows graphics.
<p>
The use of this option is discouraged, it's present only for testing.
<p>
Options:
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
none
</em></td><td width="90%">
Don't use the Windows graphics support.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
window
</em></td><td width="90%">
Create a stub window before setting the video mode.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
fullscreen
</em></td><td width="90%">
Create a stub fullscreen window before setting
the video mode (default).
</td></tr>
</table>
<h4><a name="4.6.3">4.6.3</a> 
device_svgawin_divideclock
</h4>
Divides the pixelclock using the VGA sequencer. It should help to support
lower pixel clocks on some boards.
<p>
The use of this option is discouraged, it's present only for testing.
<p>
<pre>
device_svgawin_divideclock yes | no
</pre>
<p>
Options:
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
yes
</em></td><td width="90%">
Divide the clock by 2.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
no
</em></td><td width="90%">
Don't divide the clock (default).
</td></tr>
</table>
<h2><a name="5">5</a> 
Sound Drivers Configuration
</h2>
<h4>
device_sound
</h4>
Specify the sound-card.
<p>
<pre>
device_sound auto | none | DEVICE
</pre>
<p>
Options:
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
none
</em></td><td width="90%">
No sound.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
auto
</em></td><td width="90%">
Automatic detection (default).
</td></tr>
</table>
<p>
Options for Linux:
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
alsa
</em></td><td width="90%">
ALSA sound interface.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
oss
</em></td><td width="90%">
OSS sound interface.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
sdl
</em></td><td width="90%">
SDL sound interface.
</td></tr>
</table>
<p>
Options for Mac OS X:
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
sdl
</em></td><td width="90%">
SDL sound interface.
</td></tr>
</table>
<p>
Options for DOS:
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
seal
</em></td><td width="90%">
SEAL automatic detection.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
seal/sb
</em></td><td width="90%">
Sound Blaster.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
seal/pas
</em></td><td width="90%">
Pro Audio Spectrum.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
seal/gusmax
</em></td><td width="90%">
Gravis Ultrasound Max.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
seal/gus
</em></td><td width="90%">
Gravis Ultrasound.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
seal/wss
</em></td><td width="90%">
Windows Sound System.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
seal/ess
</em></td><td width="90%">
Ensoniq Soundscape.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
allegro
</em></td><td width="90%">
Allegro automatic detection.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
allegro/sb10
</em></td><td width="90%">
Sound Blaster 1.0.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
allegro/sb15
</em></td><td width="90%">
Sound Blaster 1.5.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
allegro/sb20
</em></td><td width="90%">
Sound Blaster 2.0.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
allegro/sbpro
</em></td><td width="90%">
Sound Blaster Pro.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
allegro/sb16
</em></td><td width="90%">
Sound Blaster 16.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
allegro/audio
</em></td><td width="90%">
Ensoniq AudioDrive.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
allegro/wss
</em></td><td width="90%">
Windows Sound System.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
allegro/ess
</em></td><td width="90%">
Ensoniq Soundscape.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
vsync/sb
</em></td><td width="90%">
Sound Blaster.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
vsync/sbwin
</em></td><td width="90%">
Sound Blaster (Windows).
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
vsync/ac97
</em></td><td width="90%">
AC97.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
vsync/ac97win
</em></td><td width="90%">
AC97 (Windows).
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
vsync/gusmax
</em></td><td width="90%">
Gravis Ultrasound Max.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
vsync/gus
</em></td><td width="90%">
Gravis Ultrasound.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
vsync/audio
</em></td><td width="90%">
Ensoniq AudioDrive.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
vsync/wss
</em></td><td width="90%">
Windows Sound System.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
vsync/ess
</em></td><td width="90%">
Ensoniq Soundscape.
</td></tr>
</table>
<p>
Options Windows:
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
sdl
</em></td><td width="90%">
SDL sound interface.
</td></tr>
</table>
<h3><a name="5.1">5.1</a> 
alsa Configuration Options
</h3>
<h4><a name="5.1.1">5.1.1</a> 
device_alsa_device
</h4>
Select the alsa output device.
<p>
<pre>
device_alsa_device DEVICE
</pre>
<p>
Options:
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
DEVICE
</em></td><td width="90%">
Output device (default 'default').
</td></tr>
</table>
<p>
Other possible choices generally are 'hw:0,0' for using the
frequency and format chosen directly by the hardware, or 'dmix'
for allow concurrent access to other applications at the
audio card.
<p>
Example:
<table width="100%" border="0" cellspacing="0" cellpadding="2"><tr><td width="5%"></td><td width="95%">
<pre>
device_alsa_device dmix
</pre>
</td></tr></table>
<p>
If you want to configure the ALSA library to remap the `default' device
to the `dmix' device for all the applications, you can create
the `.asoundrc' file in your home directory with the following content:
<p>
<table width="100%" border="0" cellspacing="0" cellpadding="2"><tr><td width="5%"></td><td width="95%">
<pre>
pcm.!default {
&nbsp;&nbsp;&nbsp;&nbsp;type plug
&nbsp;&nbsp;&nbsp;&nbsp;slave.pcm "dmixer"
}

pcm.dmixer  {
&nbsp;&nbsp;&nbsp;&nbsp;type dmix
&nbsp;&nbsp;&nbsp;&nbsp;ipc_key 1024
&nbsp;&nbsp;&nbsp;&nbsp;slave {
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;pcm "hw:0,0"
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;period_time 0
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;period_size 1024
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;buffer_size 16384
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;rate 44100
&nbsp;&nbsp;&nbsp;&nbsp;}
&nbsp;&nbsp;&nbsp;&nbsp;bindings {
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0 0
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;1 1
&nbsp;&nbsp;&nbsp;&nbsp;}
}

ctl.dmixer {
&nbsp;&nbsp;&nbsp;&nbsp;type hw
&nbsp;&nbsp;&nbsp;&nbsp;card 0
}
</pre>
</td></tr></table>
<p>
Note that the suggested `.asoundrc' on the ALSA web site has a lower
`buffer_size' value (4096). For AdvanceMAME a bigger buffer is required.
<h4><a name="5.1.2">5.1.2</a> 
device_alsa_mixer
</h4>
Select the alsa mixer device.
<p>
<pre>
device_alsa_mixer DEVICE
</pre>
<p>
Options:
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
DEVICE
</em></td><td width="90%">
Mixer device. The special 'channel' value is
used to adjust the volume changing the samples
instead of using the card mixer. Other values
like `default' are used to select the ALSA mixer.
(default 'channel').
</td></tr>
</table>
<h3><a name="5.2">5.2</a> 
sdl Configuration Options
</h3>
<h4><a name="5.2.1">5.2.1</a> 
device_sdl_samples
</h4>
Select the size of the audio fragment of the SDL library.
<p>
The use of this option is discouraged, it's present only for testing.
<p>
device_sdl_samples 512 | 1024 | 2048 | 2560 | 3072 | 3584 | 4096 | 6144 | 8192
<p>
Options:
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
SAMPLES
</em></td><td width="90%">
Number of samples of an audio fragment
(default 2048 in Windows, 512 otherwise).
</td></tr>
</table>
<p>
Lower values can be used to reduce the sound latency.
Increase the value if your hear a choppy audio.
<h2><a name="6">6</a> 
Input Drivers Configuration
</h2>
<h4>
device_keyboard
</h4>
Selects the keyboard drivers.
<p>
<pre>
device_keyboard auto | none
</pre>
<p>
Options:
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
none
</em></td><td width="90%">
No keyboard.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
auto
</em></td><td width="90%">
Automatic detection (default).
</td></tr>
</table>
<p>
Options for Linux:
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
event
</em></td><td width="90%">
Linux input-event interface.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
svgalib
</em></td><td width="90%">
SVGALIB keyboard interface.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
raw
</em></td><td width="90%">
Linux kernel keyboard interface.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
sdl
</em></td><td width="90%">
SDL keyboard interface. This driver is available
only if the SDL video output is used.
</td></tr>
</table>
<p>
If you are using the SDL video driver you must also use the SDL
keyboard driver.
<p>
Options for Mac OS X:
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
sdl
</em></td><td width="90%">
SDL keyboard interface.
</td></tr>
</table>
<p>
Options for DOS:
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
allegro
</em></td><td width="90%">
Allegro keyboard interface.
</td></tr>
</table>
<p>
Options for Windows:
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
sdl
</em></td><td width="90%">
SDL keyboard interface.
</td></tr>
</table>
<h4>
device_joystick
</h4>
Selects the joystick driver.
<p>
<pre>
device_joystick auto | none | DEVICE
</pre>
<p>
Options:
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
none
</em></td><td width="90%">
No joystick (default).
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
auto
</em></td><td width="90%">
Automatic detection.
</td></tr>
</table>
<p>
Options for Linux:
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
event
</em></td><td width="90%">
Linux input-event interface.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
svgalib
</em></td><td width="90%">
SVGALIB joystick interface.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
raw
</em></td><td width="90%">
Linux kernel joystick interface.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
sdl
</em></td><td width="90%">
SDL joystick interface.
</td></tr>
</table>
<p>
Options for Mac OS X:
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
sdl
</em></td><td width="90%">
SDL joystick interface.
</td></tr>
</table>
<p>
Options for DOS:
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
allegro
</em></td><td width="90%">
Allegro automatic detection.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
allegro/standard
</em></td><td width="90%">
Standard joystick.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
allegro/dual
</em></td><td width="90%">
Dual joysticks.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
allegro/4button
</em></td><td width="90%">
4-button joystick.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
allegro/6button
</em></td><td width="90%">
6-button joystick.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
allegro/8button
</em></td><td width="90%">
8-button joystick.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
allegro/fspro
</em></td><td width="90%">
CH Flightstick Pro.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
allegro/wingex
</em></td><td width="90%">
Logitech Wingman Extreme.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
allegro/sidewinder
</em></td><td width="90%">
Sidewinder.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
allegro/sidewinderag
</em></td><td width="90%">
Sidewinder Aggressive.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
allegro/gamepadpro
</em></td><td width="90%">
GamePad Pro.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
allegro/grip
</em></td><td width="90%">
GrIP.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
allegro/grip4
</em></td><td width="90%">
GrIP 4-way.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
allegro/sneslpt1
</em></td><td width="90%">
SNESpad LPT1.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
allegro/sneslpt2
</em></td><td width="90%">
SNESpad LPT2.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
allegro/sneslpt3
</em></td><td width="90%">
SNESpad LPT3.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
allegro/psxlpt1
</em></td><td width="90%">
PSXpad LPT1.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
allegro/psxlpt2
</em></td><td width="90%">
PSXpad LPT2.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
allegro/psxlpt3
</em></td><td width="90%">
PSXpad LPT3.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
allegro/n64lpt1
</em></td><td width="90%">
N64pad LPT1.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
allegro/n64lpt2
</em></td><td width="90%">
N64pad LPT2.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
allegro/n64lpt3
</em></td><td width="90%">
N64pad LPT3.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
allegro/db9lpt1
</em></td><td width="90%">
DB9 LPT1.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
allegro/db9lpt2
</em></td><td width="90%">
DB9 LPT2.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
allegro/db9lpt3
</em></td><td width="90%">
DB9 LPT3.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
allegro/tgxlpt1
</em></td><td width="90%">
TGX LPT1.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
allegro/tgxlpt2
</em></td><td width="90%">
TGX LPT2.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
allegro/tgxlpt3
</em></td><td width="90%">
TGX LPT3.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
allegro/segaisa
</em></td><td width="90%">
IF-SEGA/ISA.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
allegro/segapci
</em></td><td width="90%">
IF-SEGA2/PCI.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
allegro/segapcifast
</em></td><td width="90%">
IF-SEGA2/PCI.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
allegro/wingwarrior
</em></td><td width="90%">
Wingman Warrior.
</td></tr>
</table>
<p>
Options for Windows:
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
sdl
</em></td><td width="90%">
SDL joystick interface.
</td></tr>
</table>
<p>
For the `allegro/psxlpt*', `allegro/db9lpt*', `allegro/tgxlpt*'
drivers you can see the source file `advance/dos/jalleg.c'
for instructions on how to build the lpt interface. See also
the Allegro library source distribution.
<h4>
device_mouse
</h4>
Selects the mouse driver.
<p>
<pre>
device_mouse auto | none
</pre>
<p>
Options:
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
none
</em></td><td width="90%">
No mouse (default).
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
auto
</em></td><td width="90%">
Automatic detection.
</td></tr>
</table>
<p>
Options for Linux:
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
event
</em></td><td width="90%">
Linux input-event interface.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
svgalib
</em></td><td width="90%">
SVGALIB mouse interface.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
raw
</em></td><td width="90%">
Direct serial communication.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
sdl
</em></td><td width="90%">
SDL mouse interface.
</td></tr>
</table>
<p>
Options for Mac OS X:
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
sdl
</em></td><td width="90%">
SDL mouse interface.
</td></tr>
</table>
<p>
Options for DOS:
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
allegro
</em></td><td width="90%">
Allegro mouse interface.
</td></tr>
</table>
<p>
Options for Windows:
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
sdl
</em></td><td width="90%">
SDL mouse interface.
</td></tr>
</table>
<h3><a name="6.1">6.1</a> 
raw Configuration Options
</h3>
<h4><a name="6.1.1">6.1.1</a> 
device_raw_mousetype[0,1,2,3]
</h4>
Select the type of the mouse.
<p>
<pre>
device_raw_mousetype[0,1,2,3] auto | DEVICE
</pre>
<p>
Devices:
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
auto
</em></td><td width="90%">
Auto detection. It works only sometimes, generally
it's better to manually select the type.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
pnp
</em></td><td width="90%">
Plug And Play serial (3 buttons).
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
ms
</em></td><td width="90%">
Microsoft Mouse serial (3 buttons).
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
ms3
</em></td><td width="90%">
Microsoft Intellimouse serial (3 buttons).
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
ps2
</em></td><td width="90%">
PS/2 (3 buttons).
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
imps2
</em></td><td width="90%">
Microsoft Intellimouse PS/2 (3 buttons).
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
exps2
</em></td><td width="90%">
Microsoft Intellimouse Explorer PS/2 (5 buttons).
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
msc
</em></td><td width="90%">
Mouse System.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
mscgpm
</em></td><td width="90%">
Mouse System compatible with GPM.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
mman
</em></td><td width="90%">
Logitech MouseMan.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
mm
</em></td><td width="90%">
Logitech MM series
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
logi
</em></td><td width="90%">
Logitech old protocol.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
bm
</em></td><td width="90%">
Bus Mouse.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
spaceball
</em></td><td width="90%">
Spacetec SpaceBall (6 buttons).
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
wacomgraphire
</em></td><td width="90%">
Wacom Graphire tablet/mouse.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
drmousee4ds
</em></td><td width="90%">
Digital Research double-wheeled mouse.
</td></tr>
</table>
<p>
The Linux mice under /dev/input/* are always of type ps2,
imps2 or exps2.
<p>
Examples:
<table width="100%" border="0" cellspacing="0" cellpadding="2"><tr><td width="5%"></td><td width="95%">
<pre>
device_raw_mousetype[0] ps2
device_raw_mousetype[1] ms
</pre>
</td></tr></table>
<h4><a name="6.1.2">6.1.2</a> 
device_raw_mousedev[0,1,2,3]
</h4>
Select the mouse device to use.
<p>
device_raw_mousedev[0,1,2,3] auto | DEVICE
<p>
Options:
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
auto
</em></td><td width="90%">
Automatically map to /dev/mouse or /dev/input/mouseX.
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
DEVICE
</em></td><td width="90%">
Complete path of the mouse device.
</td></tr>
</table>
<p>
Examples:
<table width="100%" border="0" cellspacing="0" cellpadding="2"><tr><td width="5%"></td><td width="95%">
<pre>
device_raw_mousedev[0] /dev/input/mouse0
device_raw_mousedev[1] /dev/ttyS2
</pre>
</td></tr></table>
<h3><a name="6.2">6.2</a> 
lgrawinput Configuration Options
</h3>
<h4><a name="6.2.1">6.2.1</a> 
device_lgrawinput_calibration
</h4>
Select the type of calibration of the lightgun.
<p>
device_lgrawinput_calibration auto | none
<p>
Options:
<table width="100%" border="0" cellspacing="0" cellpadding="2">
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
auto
</em></td><td width="90%">
Automatically calibrates the lightgun before
every use. You must move the lightgun over the
whole screen every time the program starts or
changes video mode (default).
</td></tr>
<tr valign="top" align="left"><td width="5%"></td><td width="5%"><em>
none
</em></td><td width="90%">
Never calibrates the lightguns, but it assumes
that the returned values are already scaled in
the range 0 - 65536.
</td></tr>
</table>


</div>

<div id="footer">

<div class="column">
<span class="bold">Donate with</span>
<br>
<a href="https://www.paypal.com/cgi-bin/webscr?cmd=_donations&business=amadvance%40gmail%2ecom&lc=US&item_name=AdvanceMAME&no_note=0&currency_code=USD&bn=PP%2dDonationsBF%3abtn_donateCC_LG%2egif%3aNonHostedGuest"><img src="paypal.png" width="160" height="60" alt="PayPal"></a>
</div>

<div class="column">
<span class="bold">Find other resources at</span>
<br>
<a href="https://github.com/amadvance/advancemame/"><img src="github.png" width="160" height="60" alt="GitHub"></a>
<a href="http://sourceforge.net/projects/advancemame/"><img src="sourceforge.png" width="115" height="60" alt="SourceForge"></a>
</div>

</div>
</body>
</html>



